config/routes.rb
Moocchat::Application.routes.draw do
  mount JasmineRails::Engine => '/specs' if defined?(JasmineRails)

  resources :conditions
  resources :activity_schemas
  resources :questions
  resources :templates

  root :to => 'tasks#static', :as => 'root'

  get '/group_formation_times/:activity_schema_id/:condition_id' =>
    'waiting_rooms#group_formation_times'

  get '/seconds_to_next_group_formation/:activity_schema_id/' =>
    'waiting_rooms#seconds_to_next_group_formation'

  get '/get_current_timestamp_utc/' =>
    'waiting_rooms#get_current_timestamp_utc'

  match '/auth/:provider/callback', :to => 'sessions#try_login'
  get '/auth/failure', :to => 'sessions#login_failed'
  post '/logout', :to => 'sessions#destroy'

  post '/tasks/:learner_name/:activity_schema_id/:condition_id' => 'tasks#create', :as => 'task_create'
  post '/tasks' => 'tasks#create' # regular form posting
  get '/tasks/turk/:condition_id' => 'tasks#create_turk' # entry point for Turk workers

  post '/tasks/:id/force_continue', :to => 'tasks#force_continue', :as => 'task_force_continue'

  post '/tasks/:id/disconnect', :to => 'tasks#disconnect', :as => 'task_disconnect'

  post '/tasks/:id/heartbeat', :to => 'tasks#heartbeat', :as => 'task_heartbeat'

  get '/tasks/error', :to => 'tasks#error', :as => 'task_error'

  get '/tasks/:id', :to => 'tasks#welcome', :as => 'task_welcome'

  post '/tasks/:id/join_group', :to => 'tasks#join_group', :as => 'task_join_group'

  get '/tasks/:id/complete', :to => 'tasks#complete', :as => 'task_complete'

  get '/tasks/:id/page', :to => 'tasks#page', :as => 'task_page'

  post '/tasks/:id/collect_response', :to => 'tasks#collect_response', :as => 'task_collect_response'

  post '/tasks/:id/next_page', :to => 'tasks#next_page', :as => 'task_next_page'

  post '/tasks/:id/log', :to => 'tasks#log', :as => 'task_log_event'

  get "users/record_consent"
  get "users/check_consent"

  get '/reports/chatlog' => 'reports#chatlog'
  post '/reports/chatlog/show' => 'reports#chatlog_show'
  get '/reports/sessions' => 'reports#sessions'
  post '/reports/sessions/show' => 'reports#sessions_show'

end

app/views/templates/_form.html.haml
.notice= @template.errors.full_messages.join('<br/>')

= form_for @template do |f|
  .control-group
    = f.label :name, "Name",:class => 'control-label'
    .controls
      = f.text_field :name, :class => 'text_field'
  .control-group
    = f.label :html,"HTML", :class => 'control-label'
    .controls
      = f.text_area :html, :class => 'text-area-html-raw'
  .form-actions
    = f.submit nil, :class => 'btn btn-primary'
    = link_to 'Cancel', templates_path, :class => 'btn'

app/views/templates/edit.html.haml
.page-header
  %h1 Edit Template

= render  :partial => 'form' 

app/views/templates/index.html.haml
.page-header
  %h1 Templates

%p= link_to 'Add New', new_template_path, :class => 'btn btn_primary'

%table.table.table-striped
  %thead
    %tr
      %th Name
      %th Last modified
      %th
      %th
  %tbody
    - @templates.each do |template|
      %tr
        %td= template.name
        %td= template.updated_at.to_formatted_s
        %td= link_to 'Preview', template_path(template), :class => 'btn btn-mini'
        %td= link_to 'Edit', edit_template_path(template), :class => 'btn btn-mini'

app/views/templates/new.html.erb
<%- model_class = @template.class-%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.new', 'New %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial =>'form' %>

app/views/templates/show.html.erb
<%- model_class = @template.class-%>
<div class="page-header">
  <h1><%=t '.title', :default => model_class.model_name.human.titleize %></h1>
</div>

<dl class="dl-horizontal">
  <dt><strong><%= model_class.human_attribute_name(:name) %>:</strong></dt><dd><%= @template.name %></dd> 
  <dt><strong><%= model_class.human_attribute_name(:url) %>:</strong></dt>
  <dd><%= @template.url %></dd>
  <dt><strong><%= model_class.human_attribute_name(:html) %>:</strong></dt>
  <dd><%= @template.html %></dd>
</dl>

<div class="form-actions">
  <%= link_to t('.back', :default => t("helpers.links.back")),
              templates_path, :class => 'btn'  %>
  <%= link_to t('.edit', :default => t("helpers.links.edit")),
              edit_template_path(@template), :class => 'btn' %>
  <%= link_to t('.destroy', :default => t("helpers.links.destroy")),
              template_path(@template),
              :method => 'delete',
              :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) },
              :class => 'btn btn-danger' %>
</div>